Index: trunk/LMDZ.COMMON/libf/phy_common/geometry_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/geometry_mod.F90	(revision 1543)
+++ trunk/LMDZ.COMMON/libf/phy_common/geometry_mod.F90	(revision 1543)
@@ -0,0 +1,74 @@
+MODULE geometry_mod
+
+! Store informations concerning the local (to MPI/OpenMP core) geometry
+
+  REAL,SAVE,ALLOCATABLE :: longitude(:) ! longitude of the cell (rad)
+!$OMP THREADPRIVATE(longitude)
+
+  REAL,SAVE,ALLOCATABLE :: latitude(:)! latitude of the cell (rad)
+!$OMP THREADPRIVATE(latitude)
+
+  REAL,SAVE,ALLOCATABLE :: longitude_deg(:) ! longitude of the cell (degree)
+!$OMP THREADPRIVATE(longitude_deg)
+
+  REAL,SAVE,ALLOCATABLE :: latitude_deg(:)! latitude of the cell (degree)
+!$OMP THREADPRIVATE(latitude_deg)
+
+  REAL,SAVE,ALLOCATABLE :: boundslon(:,:)  ! boundaries of the cell (rad)
+!$OMP THREADPRIVATE(boundslon)
+
+  REAL,SAVE,ALLOCATABLE :: boundslat(:,:) ! boundaries of the cell (rad)
+!$OMP THREADPRIVATE(boundslat)
+
+  REAL,SAVE,ALLOCATABLE :: dx(:)      ! resolution of longitude cell (valid only for 2D grid)
+!$OMP THREADPRIVATE(dx)
+  
+  REAL,SAVE,ALLOCATABLE :: dy(:)      ! resolution of latitude cell (valid only for 2D grid)
+!$OMP THREADPRIVATE(dy)
+
+  REAL,SAVE,ALLOCATABLE :: cell_area(:)      ! area of the cell
+!$OMP THREADPRIVATE(cell_area)
+
+
+CONTAINS
+
+  SUBROUTINE init_geometry(klon,longitude_,latitude_, &
+                           boundslon_,boundslat_, &
+                           cell_area_,dx_,dy_)
+  USE mod_grid_phy_lmdz, ONLY: nvertex
+  USE nrtype, ONLY : PI
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: klon ! number of columns for this MPI/OpenMP domain
+    REAL,INTENT(IN) :: longitude_(klon)
+    REAL,INTENT(IN) :: latitude_(klon)
+    REAL,INTENT(IN) :: boundslon_(klon,nvertex)
+    REAL,INTENT(IN) :: boundslat_(klon,nvertex)
+    REAL,INTENT(IN) :: cell_area_(klon)
+    REAL,OPTIONAL,INTENT(IN) :: dx_(klon)
+    REAL,OPTIONAL,INTENT(IN) :: dy_(klon)
+    
+    ALLOCATE(longitude(klon))
+    ALLOCATE(latitude(klon))
+    ALLOCATE(longitude_deg(klon))
+    ALLOCATE(latitude_deg(klon))
+    ALLOCATE(boundslon(klon,nvertex))
+    ALLOCATE(boundslat(klon,nvertex))
+    ALLOCATE(cell_area(klon))
+    IF (PRESENT(dx_)) ALLOCATE(dx(klon))
+    IF (PRESENT(dy_))ALLOCATE(dy(klon))
+    
+    longitude(:) = longitude_(:)
+    latitude(:) = latitude_(:)
+    longitude_deg(:) = longitude(:)*180./PI
+    latitude_deg(:) = latitude(:)*180./PI
+    boundslon(:,:) = boundslon_(:,:)
+    boundslat(:,:) = boundslat_(:,:)
+    cell_area(:) = cell_area_(:)
+    IF (PRESENT(dx_)) dx(:) = dx_(:)
+    IF (PRESENT(dy_)) dy(:) = dy_(:)
+    
+  END SUBROUTINE init_geometry
+
+
+END MODULE geometry_mod
+
Index: trunk/LMDZ.COMMON/libf/phy_common/ioipsl_getin_p_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/ioipsl_getin_p_mod.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/ioipsl_getin_p_mod.F90	(revision 1543)
@@ -12,5 +12,5 @@
 USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
 USE mod_phys_lmdz_omp_data, ONLY :  is_omp_root
-use mod_phys_lmdz_para, only : bcast
+USE mod_phys_lmdz_transfert_para, ONLY : bcast
 !-
 IMPLICIT NONE
Index: trunk/LMDZ.COMMON/libf/phy_common/mod_grid_phy_lmdz.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/mod_grid_phy_lmdz.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/mod_grid_phy_lmdz.F90	(revision 1543)
@@ -1,4 +1,4 @@
 !
-!$Header$
+!$Id $
 !
 MODULE mod_grid_phy_lmdz
@@ -7,9 +7,14 @@
   PRIVATE :: grid1dTo2d_glo_igen, grid1dTo2d_glo_rgen, grid1dTo2d_glo_lgen, &
              grid2dTo1d_glo_igen, grid2dTo1d_glo_rgen, grid2dTo1d_glo_lgen
-
+  
+  INTEGER,PARAMETER :: unstructured=0
+  INTEGER,PARAMETER :: regular_lonlat=1
+
+  INTEGER,SAVE :: grid_type
+  INTEGER,SAVE :: nvertex
   INTEGER,SAVE :: nbp_lon  ! == iim
-  INTEGER,SAVE :: nbp_lat  ! == jjmp1
+  INTEGER,SAVE :: nbp_lat  ! == jjmp1 (or == 1 if running 1D model)
   INTEGER,SAVE :: nbp_lev  ! == llm
-  INTEGER,SAVE :: klon_glo
+  INTEGER,SAVE :: klon_glo ! total number of atmospheric columns
 
   INTERFACE grid1dTo2d_glo
@@ -32,15 +37,18 @@
 
 
-  SUBROUTINE init_grid_phy_lmdz(iim,jjp1,llm)
+  SUBROUTINE init_grid_phy_lmdz(grid_type_,nvertex_,nbp_lon_,nbp_lat_,nbp_lev_)
   IMPLICIT NONE
-  INTEGER, INTENT(in) :: iim
-  INTEGER, INTENT(in) :: jjp1
-  INTEGER, INTENT(in) :: llm
-  
-    nbp_lon=iim
-    nbp_lat=jjp1
-    nbp_lev=llm
-    
-    ! Ehouarn: handle 1D case:
+  INTEGER,INTENT(IN)  :: grid_type_ 
+  INTEGER,INTENT(IN)  :: nvertex_ 
+  INTEGER, INTENT(IN) :: nbp_lon_
+  INTEGER, INTENT(IN) :: nbp_lat_
+  INTEGER, INTENT(IN) :: nbp_lev_
+  
+    grid_type = grid_type_
+    nvertex   = nvertex_
+    nbp_lon   = nbp_lon_
+    nbp_lat   = nbp_lat_
+    nbp_lev   = nbp_lev_
+    
     IF (nbp_lon*nbp_lat==1) THEN
       klon_glo=1
@@ -283,7 +291,9 @@
 
 !---------------------------------------------------------------- 
-!  fonctions generiques (privees)
+!  Generic (private) fonctions
 !---------------------------------------------------------------- 
+  
   SUBROUTINE grid1dTo2d_glo_igen(VarIn,VarOut,dimsize)
+
     IMPLICIT NONE
 
@@ -320,4 +330,5 @@
 
   SUBROUTINE grid1dTo2d_glo_rgen(VarIn,VarOut,dimsize)
+
     IMPLICIT NONE
 
@@ -353,4 +364,5 @@
 
   SUBROUTINE grid1dTo2d_glo_lgen(VarIn,VarOut,dimsize)
+
     IMPLICIT NONE
     
@@ -386,4 +398,5 @@
   
   SUBROUTINE grid2dTo1d_glo_igen(VarIn,VarOut,dimsize)
+
     IMPLICIT NONE
 
@@ -408,4 +421,5 @@
   
   SUBROUTINE grid2dTo1d_glo_rgen(VarIn,VarOut,dimsize)
+
     IMPLICIT NONE
 
@@ -430,4 +444,5 @@
     
   SUBROUTINE grid2dTo1d_glo_lgen(VarIn,VarOut,dimsize)
+
     IMPLICIT NONE
 
Index: trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_mpi_data.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_mpi_data.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_mpi_data.F90	(revision 1543)
@@ -3,5 +3,5 @@
 !
 MODULE mod_phys_lmdz_mpi_data
-  USE mod_const_mpi
+!  USE mod_const_mpi
   
   INTEGER,SAVE :: ii_begin
@@ -35,5 +35,6 @@
   INTEGER,SAVE :: mpi_rank
   INTEGER,SAVE :: mpi_size
-  INTEGER,SAVE :: mpi_root
+  INTEGER,SAVE :: mpi_master
+!  INTEGER,SAVE :: mpi_root
   LOGICAL,SAVE :: is_mpi_root
   LOGICAL,SAVE :: is_using_mpi
@@ -43,15 +44,21 @@
   LOGICAL,SAVE :: is_south_pole
   INTEGER,SAVE :: COMM_LMDZ_PHY
+  INTEGER,SAVE :: MPI_REAL_LMDZ   ! MPI_REAL8
 
 CONTAINS
   
-  SUBROUTINE init_phys_lmdz_mpi_data(iim,jjp1,nb_proc,distrib)
-  USE mod_const_mpi, ONLY : COMM_LMDZ
+!  SUBROUTINE Init_phys_lmdz_mpi_data(iim,jjp1,nb_proc,distrib)
+  SUBROUTINE init_phys_lmdz_mpi_data(nbp, nbp_lon, nbp_lat, communicator)
+!  USE mod_const_mpi, ONLY : COMM_LMDZ
   IMPLICIT NONE
-    INTEGER,INTENT(in) :: iim
-    INTEGER,INTENT(in) :: jjp1
-    INTEGER,INTENT(in) :: nb_proc
-    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
-    
+#ifdef CPP_MPI
+    INCLUDE 'mpif.h'
+#endif
+    INTEGER,INTENT(in) :: nbp
+    INTEGER,INTENT(in) :: nbp_lon
+    INTEGER,INTENT(in) :: nbp_lat
+    INTEGER,INTENT(in) :: communicator
+    
+    INTEGER,ALLOCATABLE :: distrib(:)
     INTEGER :: ierr
     INTEGER :: klon_glo
@@ -64,14 +71,17 @@
 #endif
     
-    if (iim.eq.1) then
+    if ((nbp_lon.eq.1).and.(nbp_lat.eq.1)) then ! running 1D column model
        klon_glo=1
     else
-       klon_glo=iim*(jjp1-2)+2
+    ! The usual global physics grid: 1 point for each pole and nbp_lon points
+    ! for all other latitudes
+       klon_glo=nbp_lon*(nbp_lat-2)+2
     endif
     
-    COMM_LMDZ_PHY=COMM_LMDZ
+    COMM_LMDZ_PHY=communicator
 
     IF (is_using_mpi) THEN    
 #ifdef CPP_MPI
+      MPI_REAL_LMDZ=MPI_REAL8
       CALL MPI_COMM_SIZE(COMM_LMDZ_PHY,mpi_size,ierr)    
       CALL MPI_COMM_RANK(COMM_LMDZ_PHY,mpi_rank,ierr)
@@ -82,6 +92,17 @@
     ENDIF
     
+    ALLOCATE(distrib(0:mpi_size-1))
+
+    IF (is_using_mpi) THEN    
+#ifdef CPP_MPI
+    CALL MPI_ALLGATHER(nbp,1,MPI_INTEGER,distrib,1,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
+#endif
+    ELSE
+     distrib(:)=nbp
+    ENDIF
+
+
     IF (mpi_rank == 0) THEN
-      mpi_root = 0
+      mpi_master = 0
       is_mpi_root = .true.
     ENDIF
@@ -115,5 +136,5 @@
   
       
-    klon_mpi_para_nb(0:mpi_size-1)=distrib(0:nb_proc-1)
+    klon_mpi_para_nb(0:mpi_size-1)=distrib(0:mpi_size-1)
 
     DO i=0,mpi_size-1
@@ -132,14 +153,14 @@
         ij_para_begin(i) = 1
       ELSE
-        ij_para_begin(i) = klon_mpi_para_begin(i)+iim-1
+        ij_para_begin(i) = klon_mpi_para_begin(i)+nbp_lon-1
       ENDIF
 
-      jj_para_begin(i) = (ij_para_begin(i)-1)/iim + 1
-      ii_para_begin(i) = MOD(ij_para_begin(i)-1,iim) + 1
+      jj_para_begin(i) = (ij_para_begin(i)-1)/nbp_lon + 1
+      ii_para_begin(i) = MOD(ij_para_begin(i)-1,nbp_lon) + 1
 
       
-      ij_para_end(i) = klon_mpi_para_end(i)+iim-1
-      jj_para_end(i) = (ij_para_end(i)-1)/iim + 1
-      ii_para_end(i) = MOD(ij_para_end(i)-1,iim) + 1
+      ij_para_end(i) = klon_mpi_para_end(i)+nbp_lon-1
+      jj_para_end(i) = (ij_para_end(i)-1)/nbp_lon + 1
+      ii_para_end(i) = MOD(ij_para_end(i)-1,nbp_lon) + 1
 
 
@@ -161,9 +182,10 @@
     klon_mpi       = klon_mpi_para_nb(mpi_rank)
    
-    CALL print_module_data
-    
-  END SUBROUTINE init_phys_lmdz_mpi_data
+    CALL Print_module_data
+    
+  END SUBROUTINE Init_phys_lmdz_mpi_data
 
   SUBROUTINE print_module_data
+!  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
   INCLUDE "iniprint.h" 
@@ -193,5 +215,5 @@
     WRITE(lunout,*) 'mpi_rank =', mpi_rank
     WRITE(lunout,*) 'mpi_size =', mpi_size
-    WRITE(lunout,*) 'mpi_root =', mpi_root
+    WRITE(lunout,*) 'mpi_master =', mpi_master
     WRITE(lunout,*) 'is_mpi_root =', is_mpi_root
     WRITE(lunout,*) 'is_north_pole =', is_north_pole
Index: trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90	(revision 1543)
@@ -9,5 +9,5 @@
                      bcast_mpi_i,bcast_mpi_i1,bcast_mpi_i2,bcast_mpi_i3,bcast_mpi_i4, &
                      bcast_mpi_r,bcast_mpi_r1,bcast_mpi_r2,bcast_mpi_r3,bcast_mpi_r4, &
-		     bcast_mpi_l,bcast_mpi_l1,bcast_mpi_l2,bcast_mpi_l3,bcast_mpi_l4
+                     bcast_mpi_l,bcast_mpi_l1,bcast_mpi_l2,bcast_mpi_l3,bcast_mpi_l4
   END INTERFACE
 
@@ -15,5 +15,5 @@
     MODULE PROCEDURE scatter_mpi_i,scatter_mpi_i1,scatter_mpi_i2,scatter_mpi_i3, &
                      scatter_mpi_r,scatter_mpi_r1,scatter_mpi_r2,scatter_mpi_r3, &
-		     scatter_mpi_l,scatter_mpi_l1,scatter_mpi_l2,scatter_mpi_l3
+                     scatter_mpi_l,scatter_mpi_l1,scatter_mpi_l2,scatter_mpi_l3
   END INTERFACE
 
@@ -22,5 +22,5 @@
     MODULE PROCEDURE gather_mpi_i,gather_mpi_i1,gather_mpi_i2,gather_mpi_i3, &
                      gather_mpi_r,gather_mpi_r1,gather_mpi_r2,gather_mpi_r3, &
-		     gather_mpi_l,gather_mpi_l1,gather_mpi_l2,gather_mpi_l3  
+                     gather_mpi_l,gather_mpi_l1,gather_mpi_l2,gather_mpi_l3  
   END INTERFACE
   
@@ -28,5 +28,5 @@
     MODULE PROCEDURE scatter2D_mpi_i,scatter2D_mpi_i1,scatter2D_mpi_i2,scatter2D_mpi_i3, &
                      scatter2D_mpi_r,scatter2D_mpi_r1,scatter2D_mpi_r2,scatter2D_mpi_r3, &
-		     scatter2D_mpi_l,scatter2D_mpi_l1,scatter2D_mpi_l2,scatter2D_mpi_l3
+                     scatter2D_mpi_l,scatter2D_mpi_l1,scatter2D_mpi_l2,scatter2D_mpi_l3
   END INTERFACE
 
@@ -34,5 +34,5 @@
     MODULE PROCEDURE gather2D_mpi_i,gather2D_mpi_i1,gather2D_mpi_i2,gather2D_mpi_i3, &
                      gather2D_mpi_r,gather2D_mpi_r1,gather2D_mpi_r2,gather2D_mpi_r3, &
-		     gather2D_mpi_l,gather2D_mpi_l1,gather2D_mpi_l2,gather2D_mpi_l3
+                     gather2D_mpi_l,gather2D_mpi_l1,gather2D_mpi_l2,gather2D_mpi_l3
   END INTERFACE 
   
@@ -45,5 +45,5 @@
     MODULE PROCEDURE grid1dTo2d_mpi_i,grid1dTo2d_mpi_i1,grid1dTo2d_mpi_i2,grid1dTo2d_mpi_i3, &
                      grid1dTo2d_mpi_r,grid1dTo2d_mpi_r1,grid1dTo2d_mpi_r2,grid1dTo2d_mpi_r3, &
-		     grid1dTo2d_mpi_l,grid1dTo2d_mpi_l1,grid1dTo2d_mpi_l2,grid1dTo2d_mpi_l3
+                     grid1dTo2d_mpi_l,grid1dTo2d_mpi_l1,grid1dTo2d_mpi_l2,grid1dTo2d_mpi_l3
  END INTERFACE 
 
@@ -51,5 +51,5 @@
     MODULE PROCEDURE grid2dTo1d_mpi_i,grid2dTo1d_mpi_i1,grid2dTo1d_mpi_i2,grid2dTo1d_mpi_i3, &
                      grid2dTo1d_mpi_r,grid2dTo1d_mpi_r1,grid2dTo1d_mpi_r2,grid2dTo1d_mpi_r3, &
-		     grid2dTo1d_mpi_l,grid2dTo1d_mpi_l1,grid2dTo1d_mpi_l2,grid2dTo1d_mpi_l3
+                     grid2dTo1d_mpi_l,grid2dTo1d_mpi_l1,grid2dTo1d_mpi_l2,grid2dTo1d_mpi_l3
  END INTERFACE 
     
@@ -1236,5 +1236,5 @@
 
   SUBROUTINE bcast_mpi_cgen(var,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     IMPLICIT NONE
     
@@ -1250,5 +1250,5 @@
     
 #ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_CHARACTER,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_BCAST(Var,nb,MPI_CHARACTER,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
         
@@ -1258,9 +1258,9 @@
       
   SUBROUTINE bcast_mpi_igen(var,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
-    IMPLICIT NONE
-    
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    
+    INTEGER,INTENT(IN) :: nb
     INTEGER,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
     
 #ifdef CPP_MPI
@@ -1272,5 +1272,5 @@
 
 #ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_INTEGER,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_BCAST(Var,nb,MPI_INTEGER,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
         
@@ -1281,9 +1281,32 @@
   
   SUBROUTINE bcast_mpi_rgen(var,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
-    IMPLICIT NONE
-    
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    
+    INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(INOUT) :: Var
+    
+#ifdef CPP_MPI
+    INCLUDE 'mpif.h'
+#endif
+    INTEGER :: ierr
+
+    IF (.not.is_using_mpi) RETURN
+
+#ifdef CPP_MPI
+    CALL MPI_BCAST(Var,nb,MPI_REAL_LMDZ,mpi_master,COMM_LMDZ_PHY,ierr)
+#endif
+    
+  END SUBROUTINE bcast_mpi_rgen
+  
+
+
+
+  SUBROUTINE bcast_mpi_lgen(var,nb)
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    
     INTEGER,INTENT(IN) :: nb
+    LOGICAL,DIMENSION(nb),INTENT(INOUT) :: Var
     
 #ifdef CPP_MPI
@@ -1295,28 +1318,5 @@
 
 #ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_REAL_LMDZ,mpi_root_x,COMM_LMDZ_PHY,ierr)
-#endif
-    
-  END SUBROUTINE bcast_mpi_rgen
-  
-
-
-
-  SUBROUTINE bcast_mpi_lgen(var,nb)
-    USE mod_phys_lmdz_mpi_data ,  mpi_root_x=>mpi_root
-    IMPLICIT NONE
-    
-    LOGICAL,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
-    
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-    INTEGER :: ierr
-
-    IF (.not.is_using_mpi) RETURN
-
-#ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_LOGICAL,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_BCAST(Var,nb,MPI_LOGICAL,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
 
@@ -1326,5 +1326,5 @@
 
   SUBROUTINE scatter_mpi_igen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1365,5 +1365,5 @@
 #ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_INTEGER,VarOut,klon_mpi*dimsize,   &
-                      MPI_INTEGER,mpi_root_x, COMM_LMDZ_PHY,ierr)
+                      MPI_INTEGER,mpi_master, COMM_LMDZ_PHY,ierr)
 #endif
 
@@ -1371,5 +1371,5 @@
 
   SUBROUTINE scatter_mpi_rgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1409,5 +1409,5 @@
 #ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_REAL_LMDZ,VarOut,klon_mpi*dimsize,   &
-                      MPI_REAL_LMDZ,mpi_root_x, COMM_LMDZ_PHY,ierr)
+                      MPI_REAL_LMDZ,mpi_master, COMM_LMDZ_PHY,ierr)
 
 #endif
@@ -1417,5 +1417,5 @@
   
   SUBROUTINE scatter_mpi_lgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1455,5 +1455,5 @@
 #ifdef CPP_MPI
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_LOGICAL,VarOut,klon_mpi*dimsize,   &
-                      MPI_LOGICAL,mpi_root_x, COMM_LMDZ_PHY,ierr)
+                      MPI_LOGICAL,mpi_master, COMM_LMDZ_PHY,ierr)
 #endif
 
@@ -1464,5 +1464,5 @@
 
   SUBROUTINE gather_mpi_igen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1493,5 +1493,5 @@
         displs(rank)=Index-1
         counts(rank)=nb*dimsize
-	Index=Index+nb*dimsize
+        Index=Index+nb*dimsize
       ENDDO
      
@@ -1500,8 +1500,8 @@
 #ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_INTEGER,VarTmp,counts,displs,   &
-                     MPI_INTEGER,mpi_root_x, COMM_LMDZ_PHY,ierr)
-#endif
-
-		          
+                     MPI_INTEGER,mpi_master, COMM_LMDZ_PHY,ierr)
+#endif
+
+                          
     IF (is_mpi_root) THEN
       Index=1
@@ -1510,5 +1510,5 @@
         DO i=1,dimsize
           VarOut(klon_mpi_para_begin(rank):klon_mpi_para_end(rank),i)=VarTmp(Index:Index+nb-1)
-	  Index=Index+nb
+          Index=Index+nb
         ENDDO
       ENDDO
@@ -1518,5 +1518,5 @@
 
   SUBROUTINE gather_mpi_rgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1542,5 +1542,5 @@
         displs(rank)=Index-1
         counts(rank)=nb*dimsize
-	Index=Index+nb*dimsize
+        Index=Index+nb*dimsize
       ENDDO
     ENDIF
@@ -1553,7 +1553,7 @@
 #ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_REAL_LMDZ,VarTmp,counts,displs,   &
-                      MPI_REAL_LMDZ,mpi_root_x, COMM_LMDZ_PHY,ierr)
-#endif
-		          
+                      MPI_REAL_LMDZ,mpi_master, COMM_LMDZ_PHY,ierr)
+#endif
+                          
     IF (is_mpi_root) THEN
       Index=1
@@ -1562,5 +1562,5 @@
         DO i=1,dimsize
           VarOut(klon_mpi_para_begin(rank):klon_mpi_para_end(rank),i)=VarTmp(Index:Index+nb-1)
-	  Index=Index+nb
+          Index=Index+nb
         ENDDO
       ENDDO
@@ -1570,5 +1570,5 @@
 
   SUBROUTINE gather_mpi_lgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1599,5 +1599,5 @@
         displs(rank)=Index-1
         counts(rank)=nb*dimsize
-	Index=Index+nb*dimsize
+        Index=Index+nb*dimsize
       ENDDO
     ENDIF
@@ -1606,7 +1606,7 @@
 #ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_LOGICAL,VarTmp,counts,displs,   &
-                      MPI_LOGICAL,mpi_root_x, COMM_LMDZ_PHY,ierr)
-#endif
-		          
+                      MPI_LOGICAL,mpi_master, COMM_LMDZ_PHY,ierr)
+#endif
+                          
     IF (is_mpi_root) THEN
       Index=1
@@ -1615,5 +1615,5 @@
         DO i=1,dimsize
           VarOut(klon_mpi_para_begin(rank):klon_mpi_para_end(rank),i)=VarTmp(Index:Index+nb-1)
-	  Index=Index+nb
+          Index=Index+nb
         ENDDO
       ENDDO
@@ -1625,5 +1625,5 @@
 
   SUBROUTINE reduce_sum_mpi_igen(VarIn,VarOut,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1633,7 +1633,7 @@
 #endif
    
+    INTEGER,INTENT(IN) :: nb
     INTEGER,DIMENSION(nb),INTENT(IN) :: VarIn
     INTEGER,DIMENSION(nb),INTENT(OUT) :: VarOut    
-    INTEGER,INTENT(IN) :: nb
     INTEGER :: ierr
    
@@ -1645,5 +1645,5 @@
 
 #ifdef CPP_MPI
-    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_SUM,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_SUM,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
             
@@ -1651,5 +1651,5 @@
   
   SUBROUTINE reduce_sum_mpi_rgen(VarIn,VarOut,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
 
@@ -1660,7 +1660,7 @@
 #endif
     
+    INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(IN) :: VarIn
     REAL,DIMENSION(nb),INTENT(OUT) :: VarOut    
-    INTEGER,INTENT(IN) :: nb
     INTEGER :: ierr
  
@@ -1671,5 +1671,5 @@
    
 #ifdef CPP_MPI
-    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_SUM,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_SUM,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
         
@@ -1707,5 +1707,5 @@
         DO ij=1,nbp_lon
          VarOut(ij,i)=VarIn(1,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1715,5 +1715,5 @@
         DO ij=nbp_lon*(jj_nb-1)+1,nbp_lon*jj_nb
          VarOut(ij,i)=VarIn(klon_mpi,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1751,5 +1751,5 @@
         DO ij=1,nbp_lon
          VarOut(ij,i)=VarIn(1,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1759,5 +1759,5 @@
         DO ij=nbp_lon*(jj_nb-1)+1,nbp_lon*jj_nb
          VarOut(ij,i)=VarIn(klon_mpi,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1796,5 +1796,5 @@
         DO ij=1,nbp_lon
          VarOut(ij,i)=VarIn(1,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1804,5 +1804,5 @@
         DO ij=nbp_lon*(jj_nb-1)+1,nbp_lon*jj_nb
          VarOut(ij,i)=VarIn(klon_mpi,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1901,2 +1901,3 @@
 
 END MODULE mod_phys_lmdz_mpi_transfert
+
Index: trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_omp_data.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_omp_data.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_omp_data.F90	(revision 1543)
@@ -1,4 +1,4 @@
 !
-!$Id: mod_phys_lmdz_omp_data.F90 1575 2011-09-21 13:57:48Z jghattas $
+!$Id: mod_phys_lmdz_omp_data.F90 2326 2015-07-10 12:24:29Z emillour $
 !
 MODULE mod_phys_lmdz_omp_data
@@ -20,5 +20,5 @@
 CONTAINS
   
-  SUBROUTINE init_phys_lmdz_omp_data(klon_mpi)
+  SUBROUTINE Init_phys_lmdz_omp_data(klon_mpi)
     USE dimphy
     IMPLICIT NONE
@@ -85,9 +85,9 @@
     klon_omp_end=klon_omp_para_end(omp_rank)
     
-    CALL print_module_data
+    CALL Print_module_data
     
-  END SUBROUTINE init_phys_lmdz_omp_data
+  END SUBROUTINE Init_phys_lmdz_omp_data
 
-  SUBROUTINE print_module_data
+  SUBROUTINE Print_module_data
   IMPLICIT NONE
   INCLUDE "iniprint.h"
@@ -106,4 +106,4 @@
 !$OMP END CRITICAL
 
-  END SUBROUTINE print_module_data
+  END SUBROUTINE Print_module_data
 END MODULE mod_phys_lmdz_omp_data
Index: trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_omp_transfert.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 1543)
@@ -25,5 +25,5 @@
                      bcast_omp_i,bcast_omp_i1,bcast_omp_i2,bcast_omp_i3,bcast_omp_i4, &
                      bcast_omp_r,bcast_omp_r1,bcast_omp_r2,bcast_omp_r3,bcast_omp_r4, &
-		     bcast_omp_l,bcast_omp_l1,bcast_omp_l2,bcast_omp_l3,bcast_omp_l4
+                     bcast_omp_l,bcast_omp_l1,bcast_omp_l2,bcast_omp_l3,bcast_omp_l4
   END INTERFACE
 
@@ -31,5 +31,5 @@
     MODULE PROCEDURE scatter_omp_i,scatter_omp_i1,scatter_omp_i2,scatter_omp_i3, &
                      scatter_omp_r,scatter_omp_r1,scatter_omp_r2,scatter_omp_r3, &
-		     scatter_omp_l,scatter_omp_l1,scatter_omp_l2,scatter_omp_l3
+                     scatter_omp_l,scatter_omp_l1,scatter_omp_l2,scatter_omp_l3
   END INTERFACE
 
@@ -38,5 +38,5 @@
     MODULE PROCEDURE gather_omp_i,gather_omp_i1,gather_omp_i2,gather_omp_i3, &
                      gather_omp_r,gather_omp_r1,gather_omp_r2,gather_omp_r3, &
-		     gather_omp_l,gather_omp_l1,gather_omp_l2,gather_omp_l3  
+                     gather_omp_l,gather_omp_l1,gather_omp_l2,gather_omp_l3  
   END INTERFACE
   
@@ -48,8 +48,15 @@
 
 
-  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp
+  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp, omp_barrier
 
 CONTAINS
 
+  SUBROUTINE omp_barrier
+  IMPLICIT NONE
+
+!$OMP BARRIER
+
+  END SUBROUTINE omp_barrier
+  
   SUBROUTINE check_buffer_i(buff_size)
   IMPLICIT NONE
@@ -733,7 +740,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Var
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -757,7 +764,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -780,7 +787,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
   
     INTEGER :: i
Index: trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_para.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_para.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/mod_phys_lmdz_para.F90	(revision 1543)
@@ -16,14 +16,14 @@
 CONTAINS
 
-  SUBROUTINE init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+  SUBROUTINE Init_phys_lmdz_para(nbp,nbp_lon,nbp_lat,communicator)
   IMPLICIT NONE
-    INTEGER,INTENT(in) :: iim
-    INTEGER,INTENT(in) :: jjp1
-    INTEGER,INTENT(in) :: nb_proc
-    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+    INTEGER,INTENT(in) :: nbp
+    INTEGER,INTENT(in) :: nbp_lon
+    INTEGER,INTENT(in) :: nbp_lat
+    INTEGER,INTENT(in) :: communicator
 
-    CALL init_phys_lmdz_mpi_data(iim,jjp1,nb_proc,distrib)
+    CALL Init_phys_lmdz_mpi_data(nbp,nbp_lon,nbp_lat,communicator)
 !$OMP PARALLEL
-    CALL init_phys_lmdz_omp_data(klon_mpi)
+    CALL Init_phys_lmdz_omp_data(klon_mpi)
     klon_loc=klon_omp
     IF (is_mpi_root .AND. is_omp_root) THEN 
@@ -32,5 +32,5 @@
        is_master=.FALSE.
      ENDIF
-    CALL test_transfert
+     CALL Test_transfert
 !$OMP END PARALLEL    
      IF (is_using_mpi .OR. is_using_omp) THEN
@@ -42,7 +42,7 @@
      ENDIF
       
-  END SUBROUTINE init_phys_lmdz_para
+  END SUBROUTINE Init_phys_lmdz_para
 
-  SUBROUTINE test_transfert
+  SUBROUTINE Test_transfert
   USE mod_grid_phy_lmdz
   IMPLICIT NONE
@@ -108,5 +108,5 @@
     
      
-   END SUBROUTINE test_transfert
+   END SUBROUTINE Test_transfert
   
 END MODULE mod_phys_lmdz_para
Index: trunk/LMDZ.COMMON/libf/phy_common/physics_distribution_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/physics_distribution_mod.F90	(revision 1543)
+++ trunk/LMDZ.COMMON/libf/phy_common/physics_distribution_mod.F90	(revision 1543)
@@ -0,0 +1,71 @@
+!
+!$Id: physics_distribution_mod.F90 2351 2015-08-25 15:14:59Z emillour $
+!
+MODULE physics_distribution_mod
+
+
+CONTAINS
+
+  SUBROUTINE init_physics_distribution(grid_type, nvertex, &
+                                       nbp, nbp_lon, nbp_lat, nbp_lev, &
+                                       communicator)
+  USE mod_phys_lmdz_para, ONLY: init_phys_lmdz_para
+  USE mod_grid_phy_lmdz, ONLY: init_grid_phy_lmdz
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: grid_type 
+    INTEGER,INTENT(IN) :: nvertex 
+    INTEGER,INTENT(IN) :: nbp           
+    INTEGER,INTENT(IN) :: nbp_lon
+    INTEGER,INTENT(IN) :: nbp_lat
+    INTEGER,INTENT(IN) :: nbp_lev
+    INTEGER,INTENT(IN) :: communicator
+
+
+    CALL init_grid_phy_lmdz(grid_type,nvertex, nbp_lon,nbp_lat,nbp_lev)
+    CALL init_phys_lmdz_para(nbp,nbp_lon, nbp_lat, communicator)
+
+  END SUBROUTINE init_physics_distribution  
+
+!SUBROUTINE Init_Phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
+!  USE mod_phys_lmdz_para, ONLY: Init_phys_lmdz_para!, klon_omp
+!  USE mod_grid_phy_lmdz, ONLY: Init_grid_phy_lmdz!, nbp_lev
+!  USE dimphy, ONLY : Init_dimphy
+!  USE infotrac_phy, ONLY : type_trac
+!#ifdef REPROBUS
+!  USE CHEM_REP, ONLY : Init_chem_rep_phys
+!#endif
+
+!  IMPLICIT NONE
+  
+!    INTEGER,INTENT(in) :: iim
+!    INTEGER,INTENT(in) :: jjp1
+!    INTEGER,INTENT(in) :: llm
+!    INTEGER,INTENT(in) :: nb_proc
+!    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+
+
+!    CALL Init_grid_phy_lmdz(iim,jjp1,llm)
+!    CALL Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+!!$OMP PARALLEL
+!    CALL Init_dimphy(klon_omp,nbp_lev)
+!
+!! Initialization of Reprobus
+!    IF (type_trac == 'repr') THEN
+!#ifdef REPROBUS
+!       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+!#endif
+!    END IF
+!
+!!$OMP END PARALLEL
+ 
+!END SUBROUTINE Init_Phys_lmdz  
+
+
+
+
+
+
+
+
+END MODULE physics_distribution_mod
+
Index: trunk/LMDZ.COMMON/libf/phy_common/write_field_phy.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/write_field_phy.F90	(revision 1542)
+++ trunk/LMDZ.COMMON/libf/phy_common/write_field_phy.F90	(revision 1543)
@@ -1,25 +1,26 @@
 !
-! $Header$
+! $Id: write_field_phy.F90 2342 2015-08-19 13:21:38Z emillour $
 !
 MODULE write_field_phy
 
+  ! Dump a field on the global (nbp_lon by nbp_lat) physics grid
+  
   CONTAINS 
  
     SUBROUTINE WriteField_phy(name,Field,ll)
-    USE dimphy
-    USE mod_phys_lmdz_para
-    USE mod_grid_phy_lmdz
-    USE Write_Field
+    USE mod_phys_lmdz_para, ONLY: klon_omp, is_mpi_root, &
+                                  Gather
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
+                                 Grid1Dto2D_glo
+    USE Write_Field, ONLY: WriteField
     
     IMPLICIT NONE
-    include 'dimensions.h'
-    include 'paramet.h'
 
-    character(len=*)   :: name
-    INTEGER :: ll
-    real, dimension(klon_omp,ll) :: Field
-    real,save,allocatable :: Field_tmp(:,:)
+    CHARACTER(len=*),INTENT(IN) :: name
+    INTEGER,INTENT(IN) :: ll
+    REAL,INTENT(IN) :: Field(klon_omp,ll)
+
     real, dimension(klon_glo,ll):: New_Field
-    real, dimension(iim,jjp1,ll):: Field_2d
+    real, dimension(nbp_lon,nbp_lat,ll):: Field_2d
 
     CALL Gather(Field,New_Field)
Index: trunk/LMDZ.GENERIC/README
===================================================================
--- trunk/LMDZ.GENERIC/README	(revision 1542)
+++ trunk/LMDZ.GENERIC/README	(revision 1543)
@@ -1203,3 +1203,10 @@
    comgeomphy.F90 instead
 
-
+== 22/04/2016 ==
+- Updates and cleanup wrt dynamics/physics separation:
+  Removed init_phys_lmdz.F90 and comgeomphy.F90 from phystd;
+  comgeomphy is replaced by geometry_mod (located in phy_common).
+  Added physics_distribution_mod.F90 in phy_common and
+  mod_interface_dyn_phys.F90 in dynphy_lonlat.
+  Added nrtype.F90 (contains math const. like PI, etc.) in "misc"
+
